#pragma once

#include <chrono>
#include <iostream>
#include <atomic>

namespace progresscpp {
using namespace std;

class ProgressBar {
private:
    atomic<unsigned int> ticks;
    atomic<int> prev_pos;

    const unsigned int total_ticks;
    const unsigned int bar_width;
    const std::chrono::steady_clock::time_point start_time = std::chrono::steady_clock::now();
public:
    ProgressBar(unsigned int total, unsigned int width, const string& name) : ticks(0), prev_pos(0), total_ticks{total}, bar_width{width} {
    	cout << name << " ";
        for (int i = 0; i < bar_width - (int)name.size() - 1; ++i)
        	cout << "=";

        cout << endl;
    }

    void operator++() {
    	float progress = (float)++ticks / total_ticks;
        int pos = (int) (bar_width * progress);
        int pp = prev_pos.exchange(pos);
        if(pp == pos)
        	return;

        for (int i = pp; i < pos; ++i)
            std::cout << ".";

        std::cout.flush();
    }

    void done() {
        std::cout << std::endl;
    }
};
}
