import numpy as np


def seq_to_ints(sequence, seq_size, reverse=False):
    if reverse:
        sequence = sequence[::-1]
        sequence = sequence.replace('A', '2')
        sequence = sequence.replace('T', '1')
        sequence = sequence.replace('G', '4')
        sequence = sequence.replace('C', '3')
        sequence = sequence.replace('N', '5')
    else:
        sequence = sequence.replace('A', '1')
        sequence = sequence.replace('T', '2')
        sequence = sequence.replace('G', '3')
        sequence = sequence.replace('C', '4')
        sequence = sequence.replace('N', '5')
    return np.array([int(x) for x in list(sequence)])[:seq_size]


def add_padding(sequence, seq_size, left_padding_size):
    result = np.zeros(seq_size + left_padding_size, dtype='int32')
    result[left_padding_size:left_padding_size + len(sequence)] = sequence
    result[:left_padding_size] = 6
    return result
