from utils.a00_common_functions import *


USE_RANKSORT = False
NORMALIZE_V2 = True
USE_SQRT = False
USE_FINAL_DISTRIBUTION_NORM = True


def rank_sort(arr):
    order = arr.argsort(axis=1)
    ranks = order.argsort(axis=1)
    return ranks


def normalize_v2(arr):
    mn = arr.min(axis=1)
    arr -= np.repeat(np.expand_dims(mn, axis=1), 1314, axis=1)
    mx = arr.max(axis=1)
    mx[mx == 0] = 10000000
    arr /= np.repeat(np.expand_dims(mx, axis=1), 1314, axis=1)
    ranks = 1314 - rank_sort(arr)
    arr /= ranks
    return arr


def normalize_submission_distibution_v1(s):
    CLASSES = get_classes()
    train = pd.read_csv(INPUT_PATH + 'train_labels.csv')
    preds = s[CLASSES].values
    real = train[CLASSES].values
    for i in range(len(CLASSES)):
        d = np.sum(real[:, i]) / np.sum(preds[:, i])
        preds[:, i] /= d
    s[CLASSES] = preds
    return s


def ensemble_submissions(subm_list, mode):
    # from tensorflow.keras.utils import to_categorical
    CLASSES = get_classes()

    seq_check = None
    matrix_full = None
    real_data = pd.read_csv(INPUT_PATH + '{}_values.csv'.format(mode), usecols=['sequence_id'])
    seq_check = tuple(real_data['sequence_id'])

    weights = []
    for path, w in subm_list:
        weights.append(w)
    print('Weights:', list(weights))

    weights = []
    for path, w in subm_list:
        weights.append(w)
        print('Read {} Weight: {}'.format(path, w))
        s = pd.read_csv(path)
        s = real_data[['sequence_id']].merge(s, on='sequence_id', how='left')
        s.fillna(0, inplace=True)
        if not seq_check:
            seq_check = tuple(s['sequence_id'])
        else:
            if seq_check != tuple(s['sequence_id']):
                print('Some error here!')
        matrix = s[CLASSES].values
        if NORMALIZE_V2:
            if matrix.max() != 1:
                print('Normalize!')
                matrix = normalize_v2(matrix).astype(np.float32)
            else:
                if USE_SQRT:
                    print('Sqrt!')
                    matrix = np.sqrt(matrix)

        if matrix_full is None:
            matrix_full = matrix.astype(np.float32).copy() * w
        else:
            matrix_full += matrix.astype(np.float32).copy() * w
    print('Weights:', list(weights))
    matrix_full /= np.array(weights, dtype=np.float32).sum()
    s[CLASSES] = matrix_full
    if mode == 'holdout':
        subm_path = SUBM_PATH + 'submission.csv'
    else:
        subm_path = SUBM_PATH + 'submission_{}.csv'.format(mode)
    print('Final submission located at: {}'.format(subm_path))
    s.to_csv(subm_path, index=False)

    if USE_FINAL_DISTRIBUTION_NORM:
        norm_subm_path = subm_path[:-4] + '_normalized.csv'
        s = normalize_submission_distibution_v1(s)
        s.to_csv(norm_subm_path, index=False)
        print('Normalized submission located at: {}'.format(norm_subm_path))

    # save_in_file(subm_list, subm_path[:-4] + '_settings.pklz')
    return subm_path


if __name__ == '__main__':
    prediction_paths = [
        (FEATURES_PATH + 'blast_sort_test.csv', 1),
        (SUBM_PATH + 'config42_test.csv', 4),
        (SUBM_PATH + 'config42_test_reverse.csv', 4),
        (SUBM_PATH + 'config45_zfturbo_test.csv', 2),
        (SUBM_PATH + 'config47_zfturbo_test.csv', 5),
        (SUBM_PATH + 'config48_test.csv', 3),
        (SUBM_PATH + 'config48_test_reverse.csv', 3),
        (SUBM_PATH + 'config50_zfturbo_test.csv', 6),
        (SUBM_PATH + 'config50_zfturbo_test_reverse.csv', 6),
        (SUBM_PATH + 'config51_zfturbo_test.csv', 6),
        (SUBM_PATH + 'config51_zfturbo_test_reverse.csv', 6),
        (SUBM_PATH + 'config52_zfturbo_test.csv', 3),
        (SUBM_PATH + 'config52_zfturbo_test_reverse.csv', 3),
        (SUBM_PATH + 'config53_zfturbo_test.csv', 2),
        (SUBM_PATH + 'config53_zfturbo_test_reverse.csv', 2),
        (SUBM_PATH + 'config55_test.csv', 3),
        (SUBM_PATH + 'config55_test_reverse.csv', 3),
    ]
    ensemble_submissions(prediction_paths, 'test')