from glob import glob
import numpy as np
import pandas as pd


def run(args):
    predicts = []
    columns = None
    index = None
    for file in glob(str(args.predicts_path) + "/*"):
        data = pd.read_csv(file, index_col='sequence_id')
        if columns is None:
            columns = data.columns
            index = data.index
        predicts.append(data.values)

    pd.DataFrame(data=np.mean(predicts, axis=0), columns=columns, index=index).to_csv('final_submission.csv')
