import os
from utils.arg_parser import parse_args
args = parse_args()
if args.gpu != '':
    print('GPU use: {}'.format(args.gpu))
    os.environ["KERAS_BACKEND"] = "tensorflow"
    os.environ["CUDA_VISIBLE_DEVICES"] = "{}".format(args.gpu)


from inference import pipeline
from ensembling import simple_avrage
from ensembling.ensemble_predictions import ensemble_submissions

pred_folder = args.predicts_path
feat_path = os.path.dirname(args.dataset_path) + '/preprocessed/blast_sort_{}.csv'.format(args.mode)
prediction_paths = [(feat_path, 1)]
weights = {
    'config42': [4, 4],
    'config45_zfturbo': [2, 0],
    'config47_zfturbo': [5, 0],
    'config48': [3, 3],
    'config50_zfturbo': [6, 6],
    'config51_zfturbo': [6, 6],
    'config52_zfturbo': [3, 3],
    'config53_zfturbo': [1, 1],
    'config55': [3, 3],
}
for conf_name in ['config42', 'config45_zfturbo', 'config47_zfturbo', 'config48',
                  'config50_zfturbo', 'config51_zfturbo', 'config52_zfturbo', 'config53_zfturbo', 'config55']:
    print('Run: {}'.format(conf_name))
    pipeline.run(args, conf_name)
    prediction_paths.append((pred_folder / '{}_{}.csv'.format(conf_name, args.mode), weights[conf_name][0]))
    prediction_paths.append((pred_folder / '{}_{}_reverse.csv'.format(conf_name, args.mode), weights[conf_name][1]))

ensemble_submissions(prediction_paths, args.mode)
# simple_avrage.run(args)