import argparse
from pathlib import Path


def str2bool(v):
    return v.lower() in ("yes", "true", "t", "1")


def str2path(v):
    return Path(v)


base_arg_parser = argparse.ArgumentParser()
base_arg_parser.add_argument('--dataset_path', type=str2path, default='../dataset')
base_arg_parser.add_argument('--models_path', type=str2path, default='../models')
base_arg_parser.add_argument('--predicts_path', type=str2path, default='../predicts')
base_arg_parser.add_argument("--float16", type=str2bool, nargs='?', const=True, default=True)
base_arg_parser.add_argument('--mode', type=str, default='test', help="test ot holdout")
base_arg_parser.add_argument('--batch_size', type=int, default=16, help="Batch size. Defult: 16")
base_arg_parser.add_argument('--gpu', type=str, default='', help="GPU to use. Default: all")


def parse_args():
    conf_parser = argparse.ArgumentParser(parents=[base_arg_parser], add_help=False)
    return conf_parser.parse_args()

