# -*- coding: utf-8 -*-
"""
Created on Mon Jan  4 22:13:03 2021

@author: IgorMehanika
"""

##############################################################################

# MODEL AND DATA PREPARATION AND TRAINING

##############################################################################

import numpy as np
import tensorflow as tf
from sklearn import preprocessing
from tensorflow import keras

# SPLIT THE DATA

#train and validation data split / 10-count var. red
red = np.array(range(0,63017,10))
XV = Xscal[red,:,:]#validation set
XT = np.delete(Xscal,range(0,63017,10),0)#train set

##############################################################################
# split labels
YV = lab[red]# val set
YT = np.delete(lab,range(0,63017,10),0)# tr set

##############################################################################
#   PREP THE DATA
#TRAIN
train_data = np.ndarray(shape = (len(XT),128,128,1),dtype = 'float32')
train_data = train_data.astype('float32')
for ii in range(0,len(XT)):
    for jj in range(0,1):
        pas = (XT[ii,:,:])/255
        train_data[ii,:,:,jj]=pas.astype('float32')  
        
 ##############################################################################  
#VALIDATION     
validation_data = np.ndarray(shape = (len(XV),128,128,1),dtype = 'float32')
validation_data = validation_data.astype('float32')
for ii in range(0,len(XV)):
    for jj in range(0,1):
        pas = (XV[ii,:,:])/255 
        validation_data[ii,:,:,jj] = pas.astype('float32')     
##############################################################################
#TEST DATA
test_data = np.ndarray(shape = (len(TestScal),128,128,1),dtype = 'float32')
test_data = test_data.astype('float32')
for ii in range(0,len(TestScal)):
    for jj in range(0,1):
        pas = (TestScal[ii,:,:])/255
        test_data[ii,:,:,jj]=pas.astype('float32')  
##############################################################################

# Encoding for categorical variables
YT = YT.astype(str)
YV = YV.astype(str)

##############################################################################

def prepare_labels(YT,YV):
    le = preprocessing.LabelEncoder()
    le.fit(YT)
    YTE = le.transform(YT)
    YVE = le.transform(YV)
    return YTE, YVE

##############################################################################

YTE,YVE = prepare_labels(YT,YV)

##############################################################################

#NOTE EXTRA CLASS 1314+1 = 1315
numcl = 1315
YT = keras.utils.to_categorical(YTE,num_classes = numcl)
YV = keras.utils.to_categorical(YVE,num_classes = numcl)

YT = tf.convert_to_tensor(YT, dtype = 'float32')
YV = tf.convert_to_tensor(YV, dtype = 'float32')

##############################################################################

train_data = tf.convert_to_tensor(train_data, dtype = 'float32')
validation_data = tf.convert_to_tensor(validation_data, dtype = 'float32')

##############################################################################
