# -*- coding: utf-8 -*-
"""
Created on Mon Dec 28 19:56:18 2020

@author: IgorMehanika
"""
##############################################################################
# NOTE:  EXECUTE IMPORTER.PY FIRST 
# IMPORTER SCRIPT DEFINES WAVELET AND WAVELET TRANSFORMATIONS USING 2 MAIN FUNCTIONS:
# analytic_wavelet_transform
# GeneralizedMorseWavelet
#THIS FUNCTIONS CALCULATE WAV.COEFS.
##############################################################################
import pandas as pd
import matplotlib.pyplot as plt
import numpy as np
import seaborn as sns
from sklearn import preprocessing
from skimage.transform import resize
sns.set()
from matplotlib.colors import ListedColormap
##############################################################################
#CUSTOM COLORMAP FOR SCALOGRAM VISUELKISATION
cmapa = np.load('cmap.npy')#load colormap matrix
colmap = ListedColormap(cmapa, name='colmap')
##############################################################################
#IMPORT DATA FOR TRANSFORMATION/FEATURE EXCTRATION AND COMPOSING AS SCALOGRAM
#DATA_DIR ='ENTER YOURS'

train_values = pd.read_csv(r'G:\Igormehanika\data\biolabdata\train_values.csv',
                           index_col='sequence_id',
                           usecols=['sequence_id','sequence'])

train_labels = pd.read_csv(r'G:\Igormehanika\data\biolabdata\train_labels.csv',
                           index_col='sequence_id')

test_values = pd.read_csv(r'G:\Igormehanika\data\biolabdata\test_values.csv',
                           index_col='sequence_id',
                           usecols=['sequence_id','sequence'])

lab_ids = pd.DataFrame(train_labels.idxmax(axis=1), columns=['lab_id'])

##############################################################################
# ALO FAOUND IN IMPORTER 
##trabsfrom sequence leters to numbers using map
def let2num(nt):
    map =[1,11,2,12,0,0,3,13,0,0,7,0,8,15,0,0,0,5,9,4,4,14,10,15,6,0,16]
    nt = nt.lower()
    number =[ord(nt)+1-ord('a') for nt in nt]
    seq = [map[number-1] for number in number]
    return seq;
##############################################################################
#double transformation use one or other
def frameSeqin2frameInteg(data):
    preved = data
    for k in range(len(preved)):
        preved.sequence[k] = let2num(preved.sequence[k]) 
    return preved
##############################################################################
pre = frameSeqin2frameInteg(train_values)#train data
# tre = frameSeqin2frameInteg(train_values)#test data
##############################################################################
#wavelet definition
def calcamorse(presek,voc):
    a =  -1.946115668748273e+05
    b =  -2.376496184989404e-04
    c =   1.944934189837382e+05
    p1 = -0.0622058729465507
    p2 = 2.657619574063227e+02
    p3 = -1.479054694938970e+05
    p4 = 23.6253072239594e+006
    p5 = -3.529610946929338e+07
    q1 = 1.595864246623817e+02
    q2 = 2.425752421282320e+04
    q3 = 1.547889826205923e+06
    q4 = -2.390715581077701e+06
    scnumb = 1 + round(a*len(presek)**b+c)
    x = np.array(range(1,scnumb), dtype=float)
    frs = np.true_divide((p1*(x**4) + p2*(x**3) + p3*(x**2) + p4*x + p5),((x**4) + q1*(x**3) + q2*(x**2) + q3*x + q4))
    frselekt = 2*np.pi*frs/voc;
    return frselekt
##############################################################################
#scal.wave calculation
def calcscales(presek,voc):
    a =  -1.946115668748273e+05
    b =  -2.376496184989404e-04
    c =    1.944934189837382e+05
    # a =  6.332784421172847e+04
    # b =  7.249815841108102e-04
    # c = -6.341837089999110e+04
    factor = 2**(1/voc)
    genscales = np.array(range(0,600),dtype=float)
    genscales[0] =  0.689988916500468/(2*np.pi)
    #genscales[0] =  2.592941518685188
    for kk in range(1,600):
        genscales[kk]=factor*genscales[kk-1]
    scnumb = round(a*len(presek)**b+c)
    scales = genscales[range(scnumb)]
    return scales
##############################################################################
# im = np.ndarray(shape = (1,128,128))
#tranform coefs
def scalogramarea(w):
    coef = resize(abs(w),(128,128), mode='constant')    
    skal = preprocessing.MinMaxScaler(feature_range=(0,1))
    skal = skal.fit(coef)
    norm = skal.transform(coef)
    im = np.uint8(norm*255)
    return im
##############################################################################
#transform data
#m = scalogramarea(wx,colmap)
red = len(train_values)
Xscal = np.ndarray(shape = (red,128,128))
def iter(sequences,red):
    for red in range(red):
        #frselekt = calcamorse(pre.sequence[red],32)
        scales = calcscales(sequences[red],32)
        psi,psi_f= GeneralizedMorseWavelet(3, 120).make_wavelet(len(sequences[red]), scales)
        wx = analytic_wavelet_transform(sequences[red],psi_f, np.isrealobj(psi))
        Xscal[red,:,:] = scalogramarea(wx)
    return Xscal
##############################################################################
# tranfrom seq.data in number form in scalograms (number of examples,128,128)
Xscal = iter(pre.sequence,red) # for TRAIN DATA SCALOGRAMS 
# TestScal = iter(tre.sequence,red) # for TEST DATA SCALOGRAMS
##############################################################################
#plot example scalogram on finish
plt.imshow(Xscal[10,:,:], cmap=colmap,interpolation='bilinear')    
# red = 1
# frselekt = calcamorse(pre.sequence[red],32)
# scales = calcscales(pre.sequence[red],32)

# psi,psi_f= GeneralizedMorseWavelet(3, 120).make_wavelet(len(pre.sequence[red]), frselekt)
# wx = analytic_wavelet_transform(pre.sequence[red],psi_f, np.isrealobj(psi))
# im = scalogramarea(wx)
# plt.imshow(im, cmap=colmap,interpolation='bilinear')   