﻿using GenEngAttr.Data;

namespace GenEngAttr.Features
{
    public static class MyBits
    {
        public static ulong[] GetMyBits(bool bTrain)
        {
            ulong[] bits = DataSet.ReadColumnsULong(bTrain: bTrain);
            int[] nnum = DataSet.ReadNNum(bTrain: bTrain);
            int[] lengths = DataSet.ReadLengths(bTrain: bTrain);
            ulong[] myBits = new ulong[bits.Length];

            for (int i = 0; i < bits.Length; i++)
            {
                myBits[i] |= ((nnum[i] > 0) ? 1UL : 0) << 0;
                myBits[i] |= ((lengths[i] <= 1085) ? 1UL : 0) << 1; // 1/3
                myBits[i] |= (((lengths[i] > 6660) || (lengths[i] <= 1085)) ? 1UL : 0) << 2; // 1/3
                myBits[i] |= ((lengths[i] <= 866) ? 1UL : 0) << 3; // 1/5
                myBits[i] |= (((nnum[i] / (float)lengths[i]) > 0.002923977) ? 1UL : 0) << 4; // 1/2

                myBits[i] |= (((bits[i] & 0x1FF80000UL) == 0) ? 1UL : 0) << 5;
                myBits[i] |= (((bits[i] & 0x7FE0000000UL) == 0) ? 1UL : 0) << 6;
            }

            return myBits;
        }

        public static ulong[] GetAllBits(bool bTrain)
        {
            ulong[] bits = DataSet.ReadColumnsULong(bTrain: bTrain);
            ulong[] myBits = GetMyBits(bTrain);

            for (int i = 0; i < bits.Length; i++)
            {
                myBits[i] = bits[i] | (myBits[i] << DataSet.NColumns);
            }

            return myBits;
        }
    }
}
