﻿using System;
using GenEngAttr.Data;
using GenEngAttr.Models;
using GenEngAttr.Utils;

namespace GenEngAttr.Features
{
    class PersonalPlasmid
    {
        public static ushort[][] SimpleSimPersonalKernel(bool bTrain, int nGramLength, int[] iPlasmids)
        {
            int[] labels = DataSet.ReadLabels();

            var (polymers, plasmids) = AllFeatures.ReadTransform2(bTrain: true, nGramLength: nGramLength);

            var (trainPolymers, trainPlasmids) = (polymers, plasmids);

            Util.Print("ReadTransform2 {0}", DateTime.Now.MyToSecString());

            bool[] disables = new bool[DataSet.NTrain];

            for (int i = 0; i < iPlasmids.Length; i++)
            {
                disables[iPlasmids[i]] = true;
            }

            if (!bTrain)
            {
                (polymers, plasmids) = AllFeatures.ReadTransform2(bTrain: false, nGramLength: nGramLength);
            }

            var (devt2Polymers, devt2Plasmids) = Transform2.Transform2GetOnlyDisables(trainPolymers, trainPlasmids, disables);

            Util.Print("Transform2GetOnlyDisables  {0}", DateTime.Now.MyToSecString());

            var res = PlasmidsSim.PlasmidsSimKernel(bTrain ? DataSet.NTrain : DataSet.NTest, iPlasmids.Length, polymers, plasmids, devt2Polymers, devt2Plasmids, new int[][] { });

            Util.Print("SimpleSimWeightKernel {0}", DateTime.Now.MyToSecString());

            return res;
        }
    }
}
