﻿using System;
using System.Collections.Generic;
using GenEngAttr.Utils;
using GenEngAttr.Data;

namespace GenEngAttr.Features
{
    class Transform3
    {
        public static Tuple<int[], int[], int[], float[]> Transform3Kernel(int[] polymers, ushort[] plasmids, int[] labels)
        {
            Util.Print("Transform3Kernel {0}", DateTime.Now);
            List<int> t3polymers = new List<int>(polymers.Length);
            List<int> t3labs = new List<int>(plasmids.Length);
            List<int> t3counts = new List<int>(plasmids.Length);
            List<int> tempLabs = new List<int>(DataSet.NLabs);
            List<float> t3shares = new List<float>(plasmids.Length);

            for (int i = 0; i < polymers.Length; i++)
            {
                tempLabs.Add(labels[plasmids[i]]);

                if ((i == polymers.Length - 1) || (polymers[i] != polymers[i + 1]))
                {
                    int count = 0, distinct = 0;
                    tempLabs.Sort();

                    for (int j = 0; j < tempLabs.Count; j++)
                    {
                        count++;
                        if ((j == tempLabs.Count - 1) || (tempLabs[j] != tempLabs[j + 1]))
                        {
                            t3polymers.Add(polymers[i]);
                            t3labs.Add(tempLabs[j]);
                            t3counts.Add(count);
                            distinct++;
                            count = 0;
                        }
                    }

                    tempLabs.Clear();

                    for (int j = 0; j < distinct; j++)
                    {
                        t3shares.Add(1f / distinct);
                    }
                }
            }

            return Util.MyTuple(t3polymers.ToArray(), t3labs.ToArray(), t3counts.ToArray(), t3shares.ToArray());
        }

        public static Tuple<int[], int[], ushort[], float[]> Transform3KernelCVDevInt(int[] polymers, int[] plasmids, int[] newLabels, bool[] disables)
        {
            Util.Print("Transform3KernelCVDevInt {0}", DateTime.Now.MyToSecString());
            List<int> t3polymers = new List<int>(polymers.Length);
            List<int> t3labs = new List<int>(plasmids.Length);
            List<ushort> t3counts = new List<ushort>(plasmids.Length);
            List<int> tempLabs = new List<int>(DataSet.NLabs);
            List<float> t3shares = new List<float>(plasmids.Length);

            for (int i = 0; i < polymers.Length; i++)
            {
                //                if (!disables[plasmids[i]])
                {
                    tempLabs.Add(newLabels[plasmids[i]]);
                }

                if ((i == polymers.Length - 1) || (polymers[i] != polymers[i + 1]))
                {
                    int count = 0, distinct = 0;
                    tempLabs.Sort();

                    for (int j = 0; j < tempLabs.Count; j++)
                    {
                        count++;
                        if ((j == tempLabs.Count - 1) || (tempLabs[j] != tempLabs[j + 1]))
                        {
                            t3polymers.Add(polymers[i]);
                            t3labs.Add(tempLabs[j]);
                            t3counts.Add((ushort)count);
                            distinct++;
                            count = 0;
                        }
                    }

                    tempLabs.Clear();

                    for (int j = 0; j < distinct; j++)
                    {
                        t3shares.Add(1f / distinct);
                    }
                }
            }

            return Util.MyTuple(t3polymers.ToArray(), t3labs.ToArray(), t3counts.ToArray(), t3shares.ToArray());
        }
    }
}
