﻿using System;
using System.Collections.Generic;
using GenEngAttr.Data;
using GenEngAttr.Features;
using GenEngAttr.Utils;

namespace GenEngAttr.Models
{
    // test plasmids to test plasmids similarity matrix
    public static class HighPlasmidsSim
    {
        public static ushort[][] GetHighPlasmidsSim(int plGramLength, int[][] resPlasmidTops)
        {
            bool[] trainTestDisables = Util.InitArray(true, DataSet.NTest);

            var (devt2PolymersFull, devt2PlasmidsFull) = AllFeatures.ReadTransform2(bTrain: false, nGramLength: plGramLength);

            ushort[][][] res = new ushort[12][][];

            Util.MyParallelFor(DataSet.NThreads6, 0, res.Length, (i) =>
            {
                var (partDisables, nDisable) = GAUtil.GetPartDisables(trainTestDisables, i, res.Length);

                var (devt2Polymers, devt2Plasmids) = Transform2.Transform2GetOnlyDisables(devt2PolymersFull, devt2PlasmidsFull, partDisables);

                int[][] devSetTops = GAUtil.GetTestSetTops(resPlasmidTops, partDisables);

                res[i] = PlasmidsSim.PlasmidsSimKernel(trainTestDisables.Length, nDisable, devt2PolymersFull, devt2PlasmidsFull, devt2Polymers, devt2Plasmids, devSetTops);
            });

            List<ushort[]> resLs = new List<ushort[]>();

            for (int i = 0; i < res.Length; i++)
            {
                resLs.AddRange(res[i]);
            }

            return resLs.ToArray();
        }

        public static ushort[][] GetHighPlasmidsSim(int plGramLength)
        {
            return GetHighPlasmidsSim(plGramLength, new int[][] { });
        }
    }
}
