﻿using GenEngAttr.Data;

namespace GenEngAttr.Models
{
    public static class PlasmidsModels
    {
        public static double[][] PlasmidsKernel(ushort[][] counts)
        {
            double mul = 0.00000001;
            int[] labels = DataSet.ReadLabels();
            int[] labsCounts = DataSet.ReadLabelsCountsNotSafeForCV();

            double[][] resLabs = new double[counts.Length][];

            for (int i = 0; i < resLabs.Length; i++)
            {
                double[] labsValue = new double[DataSet.NLabs];

                for (int j = 0; j < counts[i].Length; j++)
                {
                    if (labsValue[labels[j]] < counts[i][j])
                    {
                        labsValue[labels[j]] = counts[i][j];
                    }
                }

                for (int j = 0; j < labsValue.Length; j++)
                {

                    labsValue[j] = (labsValue[j] + labsCounts[j] * mul);
                }

                resLabs[i] = labsValue;
            }

            return resLabs;
        }

        public static double[][] GetPlasmids(int nGramLength)
        {
            ushort[][] counts = AllModels.ReadSimPlasmids(nGramLength: nGramLength);

            return PlasmidsKernel(counts);
        }

        public static double[][] GetPlasmidsHyb1(int nGramLength)
        {
            ushort[][] counts = AllModels.ReadSimPlasmidsHyb1(nGramLength: nGramLength);

            return PlasmidsKernel(counts);
        }
    }
}
