﻿# DrivenData: Genetic Engineering Attribution 

My solution to https://www.drivendata.org/competitions/63/genetic-engineering-attribution/ .

## Software Requirements

Tested on Microsoft Windows 7, Microsoft Visual Studio Community 2017, C#, .Net 4.8

## Hardware requirements

Tested on Intel Processor i7-3770K with 16GB RAM with at least 30Gb SSD. Data should be stored on SSD.

## How to build:

Install Microsoft Visual Studio Community 2017, C#, .Net 4.8. Build GenEngAttr.sln.

## How to run:

The first argument can be switch to do lesser ensembles. The last argument is the data location.
Arguments may be added to "Visual Studio/Project/GenEngAttr Properties/Debug/Command Line Arguments".
Expect creation of ~20Gb in the "data\cache" directory.
Clean the "data\cache" directory if change the test file or want a fresh start.
Expect 40 min for a full run down to 4 min for -innovation1 run.
Times may vary based on runtime optimizations, memory timings, SSD speed, etc.
The resulting file will be saved to "data\submits" directory.

```
GenEngAttr.exe c:\GenEngAttr\data
GenEngAttr.exe -innovation1 c:\GenEngAttr\data
GenEngAttr.exe -innovation2 c:\GenEngAttr\data
GenEngAttr.exe -innovation3 c:\GenEngAttr\data
GenEngAttr.exe -innovation4 c:\GenEngAttr\data
```
## Performance table

Accuracy was measured on tuned cross-validation (mostly within ±0.1% of the public leaderboard score):

Ensemble | Time on i7-3770K | Accuracy | Note | Switch
---|---|---|---|---
T3 solo | 4m08s | baseline | best solo | -innovation1
T3 + T3 Hybrid1 | 4m40s | +0.51% | fast, easy to add | -innovation2
All genetics | 26m18s | +0.99% | genetic only | -innovation3
T3+Hyb1+non-genetic | 4m58s | +2.21% | best fast | -innovation4
All | 40m26s | +2.80% | best accuracy |

