Please make sure all the requirements are installed before executing the code. Recommended python version is 3.7.5.

Hardware: 128GB RAM, 2 RTX 2080TI. Other hardware may work but not tested.

## Steps:
1. move all the data to this directory (code_sub/)


###Depends if training model from scratch, you can go with either step 2a or step 2b to generate submission csv.
### Note: only 1 random seed per model type is included for pretrained models, the full model each has 5 seeds. So 
### there is a bit of randomness which may have a tiny impact (<0.0005) on the model performance. It is recommended to run step 
### 2a to fully reproduce the models for the best accuracy. Run step 2b just to validate the code and approach.

**Warning**: If you are rerunning this script, make sure to delete all artifacts from previous runs. This includes the `*_fea.pk` feature outputs from running `prepare_data.py`. This also includes the `gk_submissions.csv` file that is output at the end of this pipeline. These files are not automatically over-written and so need to be deleted before every run.

2a. Run the scripts as follows to reproduce the submission result:
    i. `python prepare_data.py`:  this prepares (i.e. tokenizes) the raw data
    
    ii. `python train_nn.py 8000 false`: train a model with sequence length 8000, without loading pretrained model,
    the model is trained on 5 fold and averaged 5 times with different seeds.
    
    iii. `python train_nn.py 10000 false`: similar with step ii but with sequence length 10,000.
    
    iv. `python train_nn.py 12000 false`: similar with step ii but with sequence length 12,000.
    
    v. `python gen_sub.py`: generate the submission csv with all the models averaged, which can be found as "yx_submission.csv".
   

2b. Run the scripts as follows to load pretrained models and do inference directly:
    i. `python prepare_data.py`:  this prepares (i.e. tokenizes) the raw data
    
    ii. `python train_nn.py 8000 true`: train a model with sequence length 8000, without loading pretrained model,
    the model is trained on 5 fold and averaged 5 times with different seeds.
    
    iii. `python train_nn.py 10000 true`: similar with step ii but with sequence length 10,000.
    
    iv. `python train_nn.py 12000 true`: similar with step ii but with sequence length 12,000.
    
    v. `python gen_sub.py`: generate the submission csv with all the models averaged, which can be found as "yx_submission.csv".

