# coding: utf-8
__author__ = 'ZFTurbo: https://www.drivendata.org/users/ZFTurbo/'


from utils.a00_common_functions import *


def merge_sample_subm(in_path):
    s = pd.read_csv(INPUT_PATH + 'holdout_values.csv')
    feat = pd.read_csv(in_path)
    feat = s[['sequence_id']].merge(feat, on='sequence_id', how='left')
    feat.fillna(0, inplace=True)
    # feat.to_csv(SUBM_PATH + os.path.basename(in_path), index=False)
    feat.to_csv(in_path, index=False)


def proc_data_output_all_found_classes(type='holdout'):
    print('Read training data...')
    answs = get_id_to_class_dict()
    CLASSES = get_classes()
    # print(len(CLASSES))
    # class_counts = get_class_counts()
    # predictions = []
    headers = ['query_id', 'subject_id', 'identity', 'alignment length', 'mismatches', 'gap opens', 'q.start',
               'q.end', 's.start', 's.end', 'evalue', 'bit score']

    res = dict()
    files = glob.glob(CACHE_PATH + '/blast_res_holdout/*.csv')
    found_classes = dict()
    for f in files:
        print('Go for: {}'.format(f))
        s = pd.read_csv(f, sep='\t', names=headers, index_col=False)
        qids = s['query_id'].values
        sids = s['subject_id'].values

        for i in range(len(qids)):
            id, sid = qids[i], sids[i]
            if id not in res:
                res[id] = np.zeros((len(CLASSES)), dtype=np.float32)
                found_classes[id] = set()
            class_id = answs[sid]
            found_classes[id] = found_classes[id] | set([class_id])
            if res[id][class_id] == 0:
                res[id][class_id] = 1 / len(found_classes[id])

    feat_path = FEATURES_PATH + 'blast_sort_{}.csv'.format(type)
    out = open(feat_path, 'w')
    out.write('sequence_id')
    for c in CLASSES:
        out.write(',{}'.format(c))
    out.write('\n')

    for el in sorted(list(res.keys())):
        out.write(el)
        for i in range(len(CLASSES)):
            out.write(',{}'.format(res[el][i]))
        out.write('\n')
    out.close()

    merge_sample_subm(feat_path)
    print('Feature generated: {}'.format(feat_path))


if __name__ == '__main__':
    proc_data_output_all_found_classes('holdout')


