# coding: utf-8
__author__ = 'ZFTurbo: https://www.drivendata.org/users/ZFTurbo/'


from utils.a00_common_functions import *


def create_pca_for_single_matrix(file_path, transformer_path):
    # from scipy.sparse import csr_matrix, load_npz
    print(file_path)
    ids1, matrix = load_from_file(file_path)
    print('Matrix read complete... {} {}'.format(len(ids1), matrix.shape))
    print('Create PCA...')
    transformer = load_from_file_fast(transformer_path)
    X = transformer.transform(matrix)
    print('Transform_complete!')
    # save_in_file((ids, X), FEATURES_PATH + os.path.basename(file_path))
    ids = [x.split('_')[0] for x in ids1 if 'holdout' in x]
    PCA = pd.DataFrame(data=X[:len(ids)], columns=['f' + str(i) for i in range(1024)], index=ids)
    PCA.index.name = 'sequence_id'
    PCA.to_csv(FEATURES_PATH + os.path.basename(file_path)[:-5] + '.csv')


if __name__ == '__main__':
    files = glob.glob(CACHE_PATH + "pca_*_holdout.pklz")
    for feature_vector_path in files:
        pca_transformer_path = MODELS_PATH + 'pca/' + os.path.basename(feature_vector_path)[:-13] + '_1024_PCA_transformer.pkl'
        create_pca_for_single_matrix(
            feature_vector_path,
            pca_transformer_path
        )
