# coding: utf-8
__author__ = 'ZFTurbo: https://www.drivendata.org/users/ZFTurbo/'


from utils.a00_common_functions import *

USE_LARGE = False


def merge_train_subm(in_path):
    s = pd.read_csv(INPUT_PATH + 'train_labels.csv')
    feat = pd.read_csv(in_path)
    feat = s[['sequence_id']].merge(feat, on='sequence_id', how='left')
    feat.fillna(0, inplace=True)
    feat.to_csv(in_path, index=False)


def proc_data_output_all_found_classes_leave_one_out():
    answs = get_id_to_class_dict()
    CLASSES = get_classes()
    # print(len(CLASSES))
    headers = ['query_id', 'subject_id', 'identity', 'alignment length', 'mismatches', 'gap opens', 'q.start',
               'q.end', 's.start', 's.end', 'evalue', 'bit score']

    res = dict()
    if USE_LARGE:
        dir_path = CACHE_PATH + '/blast_res_full_vs_full_9999999/'
    else:
        dir_path = CACHE_PATH + '/blast_res_full_vs_full_999/'
    files = glob.glob(dir_path + '*.csv')
    print('Files found: {}'.format(len(files)))
    if len(files) == 0:
        print('There is no BLAST files in folder: {}. Please check it!'.format(dir_path))

    found_classes = dict()
    for f in files:
        print('Go for: {}'.format(f))
        in1 = open(f, 'r')
        while 1:
            line = in1.readline()
            if not line:
                break
            arr = line.split('\t')
            qid, sid = arr[0], arr[1]
            if '_test' in qid:
                continue
            if '_test' in sid:
                continue
            if qid == sid:
                continue
            id = qid[:-6]
            sid = sid[:-6]
            if id not in res:
                res[id] = np.zeros((len(CLASSES)), dtype=np.float32)
                found_classes[id] = set()
            class_id = answs[sid]
            found_classes[id] = found_classes[id] | set([class_id])
            if res[id][class_id] == 0:
                res[id][class_id] = 1 / len(found_classes[id])

        in1.close()

    if USE_LARGE:
        feat_path = FEATURES_PATH + 'blast_sort_train_large.csv'
    else:
        feat_path = FEATURES_PATH + 'blast_sort_train.csv'
    out = open(feat_path, 'w')
    out.write('sequence_id')
    for c in CLASSES:
        out.write(',{}'.format(c))
    out.write('\n')

    for el in sorted(list(res.keys())):
        out.write(el)
        for i in range(len(CLASSES)):
            out.write(',{}'.format(res[el][i]))
        out.write('\n')
    out.close()
    merge_train_subm(feat_path)


if __name__ == '__main__':
    proc_data_output_all_found_classes_leave_one_out()


